/* MDB Tools - A library for reading MS Access database file
 * Copyright (C) 2000 Brian Bruns
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include "mdbtools.h"

char *type_name[] = {"Form",
			"Table",
			"Macro",
			"System Table",
			"Report",
			"Query",
			"Linked Table",
			"Module",
			"Unknown 0x08",
			"Unknown 0x09",
			"Unknown 0x0a",
			"Unknown 0x0b"
		};

main(int argc, char **argv)
{
off_t offset=0;
int   fd, i, j;
char  xdigit;
short digit;
struct stat status;
int rows, cur, off;
unsigned char buf[2048];


	if (argc<2) {
		fprintf(stderr,"Usage: mdbdump <file> <offset>\n");
		fprintf(stderr,"     : offset is a hex offset to the KKD to dump\n");
		exit(1);
	}
	
	fd = mdb_open(argv[1],O_RDONLY);

	for (i=0;i<strlen(argv[2]);i++) {
		xdigit = argv[2][i];
		if (isalpha(xdigit)) digit = 10 + toupper(xdigit) - 'A';
		if (isdigit(xdigit)) digit = xdigit - '0';
		offset <<= 4;
		offset += digit;
	}

	fstat(fd, &status);
	if (status.st_size < offset) {
		fprintf(stderr,"offset %lu is beyond EOF\n",offset);
		close(fd);
		exit(1);
	}
	lseek(fd, offset, SEEK_SET);
	
	mdb_read(fd, buf, 2048); /* header */
	rows = buf[8] + buf[9]*256;
	fprintf(stdout, "Number of rows: %d\n",rows);
	cur = 10;
	for (i=0;i<rows;i++) {
		/* ??? this happens, don't know what it means */
		if (buf[cur+1] & 0xF0) {
			cur += 2;
		} else {
			off = buf[cur] + buf[cur+1]*256;
			cur += 2;
			fprintf(stdout,"Offset: %4d Num: %2d Type: %-15s Name: ",off,buf[off+1],type_name[buf[off+9]]);
			for (j=off+31;isprint(buf[j]);j++)
				fprintf(stdout,"%c",buf[j]);
			fprintf(stdout,"\n");

/*
			for (j=off;j<off+32;j++) 
				fprintf(stdout,"%02x ",buf[j]);
			fprintf(stdout,"\n");
*/
		}
	}
}

